1  '********************************************************************
2  '*                                                                  *
3  '*       HOST COMMUNICATIONS SAMPLE PROGRAM FOR BASIC               *
4  '*                                                                  *
5  '*       (communicating without the async device driver)            *
6  '*                                                                  *
7  '********************************************************************
8  '
10 PRINT "HOST COMMUNICATIONS SAMPLE PROGRAM"
11 '
20 XMITRC = 0				 'TRANSMIT RETURN CODE
30 RECVRC = 0				 'RECEIVE RETURN CODE (#CHARS RECEIVED)
40 MSGOUT$ = ""                          'MESSAGE TO BE TRANSMITTED
50 MSGIN$ = ""                           'MESSAGE RECEIVED
60 OPEN "COM1:9600,N,8,2,CS,DS" AS #1    'OPEN COMMUNICATIONS LINE
70 '
80 '--------------------------------------------------------------------
90 '
100 MSGOUT$ = "0 1 320 'APPL1'"             '<----- SELECT APPL1
115 '
120 GOSUB 5000				    ' SEND MESSAGE TO HOST
125 '
130 IF XMITRC <> 0 THEN PRINT "COULD NOT TRANSMIT: ";MSGOUT$ : END
131 PRINT "TRANSMITTED: "; MSGOUT$
135 '
150 GOSUB 6000				    ' GET HOST REPLY
151 '
155 IF MID$(MSGIN$,1,1) = "1" THEN PRINT "TRANSACTION OK" : GOTO 170
156 PRINT "** ERROR **   : "; MSGIN$
160 '
165 '-------------------------------------------------------------------
166 '
170 MSGOUT$ = "0 2 205 3"                   '<----- START APPL1
180 '
185 GOSUB 5000				    ' SEND MESSAGE TO HOST
190 '
195 IF XMITRC <> 0 THEN PRINT "COULD NOT TRANSMIT: ";MSGOUT$ : END
196 PRINT "TRANSMITTED: "; MSGOUT$
200 '
205 GOSUB 6000				    ' GET HOST REPLY
210 '
220 IF MID$(MSGIN$,1,1) = "1" THEN PRINT "TRANSACTION OK" : GOTO 245
221 PRINT "** ERROR **   : "; MSGIN$
230 '
235 '-------------------------------------------------------------------
240 '
245 MSGOUT$ = "0 3 204 3"                   '<----- STOP APPL1
250					    '       AT CYCLE END
255 '
260 GOSUB 5000				    ' SEND MESSAGE TO HOST
265 '
270 IF XMITRC <> 0 THEN PRINT "COULD NOT TRANSMIT: ";MSGOUT$ : END
271 PRINT "TRANSMITTED: "; MSGOUT$
275 '
280 GOSUB 6000				    ' GET HOST REPLY
285 '
290 IF MID$(MSGIN$,1,1) = "1" THEN PRINT "TRANSACTION OK" : GOTO 305
291 PRINT "** ERROR **   : "; MSGIN$
295 '-------------------------------------------------------------------
300 '
305 MSGOUT$ = "0 4 221 'P4=PT(-400,300,-30)'"  '<----- CHANGE POINT 4
310 '
315 GOSUB 5000				    ' SEND MESSAGE TO HOST
320 '
330 IF XMITRC <> 0 THEN PRINT "COULD NOT TRANSMIT: ";MSGOUT$ : END
331 PRINT "TRANSMITTED: "; MSGOUT$
340 '
345 GOSUB 6000				    ' GET HOST REPLY
350 '
355 IF MID$(MSGIN$,1,1) = "1" THEN PRINT "TRANSACTION OK" : GOTO 370
356 PRINT "** ERROR **   : "; MSGIN$
360 '-------------------------------------------------------------------
365 '
370 MSGOUT$ = "0 5 205 3"                   '<----- START APPL1 AGAIN
380 '
385 GOSUB 5000				    ' SEND MESSAGE TO HOST
390 '
395 IF XMITRC <> 0 THEN PRINT "COULD NOT TRANSMIT: ";MSGOUT$ : END
396 PRINT "TRANSMITTED: "; MSGOUT$
400 '
405 GOSUB 6000				    ' GET HOST REPLY
410 '
415 IF MID$(MSGIN$,1,1) = "1" THEN PRINT "TRANSACTION OK" : GOTO 430
416 PRINT "** ERROR **   : "; MSGIN$
420 '-------------------------------------------------------------------
425 '
430 MSGOUT$ = "0 6 204 3"                   '<----- STOP APPL1
435					    '       AT CYCLE END
440 '
445 GOSUB 5000				    ' SEND MESSAGE TO HOST
450 '
455 IF XMITRC <> 0 THEN PRINT "COULD NOT TRANSMIT: ";MSGOUT$ : END
456 PRINT "TRANSMITTED: "; MSGOUT$
460 '
465 GOSUB 6000				    ' GET HOST REPLY
470 '
475 IF MID$(MSGIN$,1,1) = "1" THEN PRINT "TRANSACTION OK" : GOTO 485
476 PRINT "** ERROR **   : "; MSGIN$
480 '*------------------------------------------------------------------
485 PRINT "HOST COMMUNICATIONS SAMPLE PROGRAM ENDED"
490 END
500 '-------------------------------------------------------------------
501 '
5000 '******************************************************************
5001 '*                                                                *
5002 '*       BASIC ROUTINE TO PERFORM AML/2 SENDMSG FUNCTION          *
5003 '*                                                                *
5004 '******************************************************************
5005 '
5010 DEFINT A-Z 		     'MAKE ALL UNTYPED VARIABLES INTEGER
5030 STX$ = CHR$(02)		     'SPECIFY ALL NEEDED COMMUNICATIONS
5040 ETX$ = CHR$(03)		     '  CONTROL CHARACTERS
5050 ACK$ = CHR$(06)
5055 NAK$ = CHR$(21)
5060 ETX = 3
5090 '
5100 'CALCULATE CHECKSUM VALUE OF OUTGOING MESSAGE
5110 '
5120 MSGLEN = LEN(MSGOUT$)			 'GET MESSAGE LENGTH
5130 CKSUM = MSGLEN				 'START CHECKSUM ACCUMULATION
5140 '
5150 FOR I = 1 TO MSGLEN
5160   CKSUM = CKSUM + ASC(MID$(MSGOUT$,I,1))	 'SUM EACH CHAR IN MESSAGE
5170 NEXT I
5180 '
5190 CKSUM = (CKSUM + ETX) MOD 256		 'ADD ETX AND CALC MOD 256 SUM
5200 CKSUM$ = CHR$(CKSUM)			 'CONVERT VALUE TO CHAR
5205 '
5210 MSGLEN$ = CHR$(MSGLEN/256) + CHR$(MSGLEN MOD 256)	'CALC MSG LENGTH IN HEX
5230 MSGX$ = STX$ + MSGLEN$ + MSGOUT$ + ETX$ + CKSUM$	'GLUE MSG TOGETHER
5240 PRINT #1, MSGX$					'TRANSMIT MESSAGE
5250 '
5260 'WAIT FOR ACK AND VERIFY MESSAGE WAS SENT O.K.
5270 '
5280 WHILE LOC(1) = 0: WEND			 'LOOP WAITING TO RECEIVE DATA
5300 RESP$ = INPUT$(1,#1)			 'GET RESPONSE CHARACTER
5310 IF RESP$ = ACK$ THEN XMITRC = 0: RETURN	 'IF ACK RECEIVED, SET GOOD RET
5320 IF LOC(1) > 0 THEN GOTO 5300 ELSE XMITRC = -1: RETURN  'ELSE SET BAD RETURN
5900 '*-----------------------------------------------------------------
5910 '
6000 '******************************************************************
6001 '*                                                                *
6002 '*       BASIC ROUTINE TO PERFORM AML/2 READMSG FUNCTION          *
6003 '*                                                                *
6004 '******************************************************************
6005 '
6005 WHILE LOC(1) < 4: WEND		'WAIT UNTIL FIRST 4 CHARS ARE RECVD
6010 RESP$ = INPUT$(4,#1)		'GO READ THEM
6020 '
6030 WHILE RIGHT$(RESP$,1) <> ETX$	'LOOP UNTIL COMPLETE MSG IS RECEIVED
6040   WHILE LOC(1) = 0: WEND
6050   RESP$ = RESP$ + INPUT$(1,#1)	'READ MESSAGE ONE CHAR AT A TIME
6060 WEND
6070 '
6080 A$ = INPUT$(1,#1)			    'TOSS CHECKSUM CHARACTER
6090 PRINT #1, ACK$			    'ACKNOWLEDGE MESSAGE
6100 MSGIN$ = MID$(RESP$,4,(LEN(RESP$)-4))  'GET MESSAGE MINUS CONTROL C
6110 RECVRC = LEN(MSGIN$)		    'RETURN No. OF CHARS RECEIVED
6120 RETURN
6900 '*-----------------------------------------------------------------
